/*
 * This file is part of Nuts Framework.
 * Copyright(C) 2009-2012 Nuts Develop Team.
 *
 * Nuts Framework is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License any later version.
 * 
 * Nuts Framework is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Nuts Framework. If not, see <http://www.gnu.org/licenses/>.
 */
package nuts.blank.action;

import nuts.blank.util.ActionConsts;
import nuts.blank.util.ActionUtils;
import nuts.exts.struts2.CookieStateProvider;


/**
 * AbstractAction.
 */
@SuppressWarnings("serial")
public abstract class AbstractAction extends nuts.aems.action.AbstractAction {

	/**
	 * Constructor
	 */
	public AbstractAction() {
		setStateProvider(new CookieStateProvider(this));
	}

	/**
	 * @return the consts
	 */
	public ActionConsts consts() {
		return (ActionConsts)super.getConsts();
	}

	/**
	 * @return the utils
	 */
	public ActionUtils utils() {
		return (ActionUtils)super.getUtils();
	}
}
