/*
 * This file is part of Nuts Framework.
 * Copyright(C) 2009-2012 Nuts Develop Team.
 *
 * Nuts Framework is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License any later version.
 *
 * Nuts Framework is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Nuts Framework. If not, see <http://www.gnu.org/licenses/>.
 */
package nuts.core.bind;

import java.io.StringReader;
import java.lang.reflect.Type;

public abstract class AbstractDeserializer extends AbstractBinder implements Deserializer {
	private boolean ignoreReadonlyProperty = false;

	/**
	 * 
	 */
	public AbstractDeserializer() {
	}

	/**
	 * @return the ignoreReadonlyProperty
	 */
	public boolean isIgnoreReadonlyProperty() {
		return ignoreReadonlyProperty;
	}

	/**
	 * @param ignoreReadonlyProperty the ignoreReadonlyProperty to set
	 */
	public void setIgnoreReadonlyProperty(boolean ignoreReadonlyProperty) {
		this.ignoreReadonlyProperty = ignoreReadonlyProperty;
	}

	/**
	 * Creates a object from a string, with a specific target class.<br>
	 */
	public <T> T deserialize(String source, Type type) {
		return deserialize(new StringReader(source), type);
	}
}
